<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");
      label.required {
      	font-weight: bold;
      	color: #990033;
      }
    </style>
  </head>

  <body>
    <form name="form" action="<%=response.encodeURL("action.jsp")%>" method="POST">
      <div id="header">
        <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
        <% String pageURL = action+"Incident.jsp"; %>
        <input type="hidden" name="pageURL" value="<%=pageURL%>"/>
        <% String forceUpdate = request.getParameter("forceUpdate") != null ? (String)request.getParameter("forceUpdate") : "";%>
        <input type="hidden" name="forceUpdate" value="<%=forceUpdate%>" />              
        
        
        <%
        if(request.getParameter("tab") != null)
        {
          %>
          <input type="hidden" name="tab" value="<%=request.getParameter("tab")%>"/>
          <%
        }
        ServiceManagerIncident incident = (ServiceManagerIncident)session.getAttribute("incident");
        Map<String, String> fieldTypes = new HashMap<String, String>();
        Map<String, String> fields = new LinkedHashMap<String, String>();
        Collection<String> requiredFields = new ArrayList<String>();
        if(incident != null)
        {
          if("create".equals(action))
          {
            incident.addUpdate("Category", "incident");
            %>
            <%@ include file="createFields.jsp"%>
            <%
          }
          else
          {
            %>
            <%@ include file="updateFields.jsp"%>
            <%
          }
          %>
          <br><%
          String header = "New Incident";
          if(!"create".equals(action))
          {
            header = incident.getTextValue("IncidentID")+" - "+incident.getTextValue("BriefDescription");
            int MAX_HEADER = 30;
            if(header.length() > MAX_HEADER)
              header = header.substring(0, MAX_HEADER-3)+"...";
          }
          out.print(header);
        }
        %>
      </div>

      <div id="content">
        <%
        if(request.getParameter("errorMessage") != null)
          out.print("<div class=\"msg-error\">"+request.getParameter("errorMessage")+"</div>");
        else if (request.getParameter("message") != null)
          out.print("<div class=\"msg-success\">"+request.getParameter("message")+"</div>");

        if(incident != null){
        %>


        <table class="no-border">
          <%
          for(String key : fields.keySet())
          {
            String name = key;
            String label = fields.get(key);
            String labelAttr = "";
            if(requiredFields.contains(name))
              labelAttr = " class=\"required\"";
          %>
          <tr>
            <a name="<%=key%>"/>
            <td style="vertical-align: middle;" class="align-right"><label<%=labelAttr%>><%=label%>:</label></td>
            <td>
              <%
              if("ReadOnly".equalsIgnoreCase(fieldTypes.get(key)))
              {
                if(incident.isListField(name))
                {
                  for(String value : incident.getListValue(name, true))
                    out.println(value+"<br>");
                }
                else
                {
                  out.print(incident.getTextValue(name, true));
                }
              }
              else if("WriteOnly".equalsIgnoreCase(fieldTypes.get(key)))
              {
                String value = "";
                if(incident.getUpdateMap().get(key) != null)
                  value = incident.getUpdateMap().get(key);
                %> 
                <textarea name="<%=name%>"><%=value%></textarea> 
                <%
              }
              else if("Text".equalsIgnoreCase(fieldTypes.get(key)))
              {
                if(incident.isListField(name))
                {
                  %><textarea name="<%=name %>"><%
                  boolean first = true;
                  for(String value : incident.getListValue(name))
                  {
                    if(!first)
                    {
                      out.println();
                    }
                    else
                    {
                      first = false;
                    }
                    
                    // Check if the value has been updated - if so, retrieve from the update map
                    if (incident.getUpdateMap().get(key) != null)
                    {
                        value = incident.getUpdateMap().get(key);
                    }
                    out.print(value);
                  }
                  %></textarea><%
                }
                else
                {
                  %> 
                  <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                  <%
                }
              }
              else if("Boolean".equalsIgnoreCase(fieldTypes.get(key))){
                Boolean value = new Boolean(incident.getTextValue(key));
                %>
                <input type="hidden" name="<%=name%>" value="false"/>
                <input type="checkbox" name="<%=name%>" value="true" <%if(value) out.println("checked=\"true\"");%> />
                <%
              }
              else if("ReadOnlyBoolean".equalsIgnoreCase(fieldTypes.get(key))){
                Boolean value = new Boolean(incident.getTextValue(key));
                %>
                <input type="hidden" name="<%=name%>" value="<%=incident.getTextValue(key)%>"/>
                <input type="checkbox" disabled="true" name="<%=name%>" value="true" <%if(value) out.println("checked=\"true\"");%> />
                <%
              }
              else if("List".equalsIgnoreCase(fieldTypes.get(key)) | fieldTypes.get(key).startsWith("DynamicList"))
              {
                String dependsOn = fieldTypes.get(key).replaceFirst("DynamicList-", "");
                if(!"List".equalsIgnoreCase(dependsOn) && !"DynamicList".equalsIgnoreCase(dependsOn))
                  incident.updateDynamicList(key, dependsOn);
                if(incident.getList(key) != null)
                {
                  String onchange = "";
                  if(fieldTypes.get(key).startsWith("DynamicList"))
                    onchange = "onchange=\"document.form.submit();\"";
                      //Add the following to send the page to the fields anchor
                      //document.form.action = document.form.action+'#"+key+"';
                  %> 
                  <select name="<%=name%>" <%=onchange%>>
                    <%
                    if(!requiredFields.contains(name))
                    {
                      %>
                      <option value=""></option>
                      <%
                    }
                    Collection<String> options = incident.getList(key);
                    for(String value: options)
                    {
                      String attrs = " value=\""+value+"\" ";
                      if(value.equals(incident.getTextValue(name, true)))
                        attrs += "selected=\"selected\" ";
                      String option = value;
                      if(option.length() > 23)
                        option = option.substring(0,20)+"...";
                      out.print("<option"+attrs+">"+option+"</option>");
                    }
                    %>
                  </select> 
                  <%
                }
                else
                {
                  %> 
                  <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                  <%
                }
              }
              else if("Date".equalsIgnoreCase(fieldTypes.get(key)))
              {
                String value = XMLDateParser.getDisplayDate(incident.getTextValue(key));
                %>
                <input type="text" name="<%=name+"-DATE"%>" value="<%=value%>"/>
                <br><i>mm/dd/yy hh:mm in GMT</i>
                <%
              }
              else if("ReadOnlyDate".equalsIgnoreCase(fieldTypes.get(key)))
              {
                String value = XMLDateParser.getDisplayDate(incident.getTextValue(key));
                out.print(value);
              }
              else if("Operator".equalsIgnoreCase(fieldTypes.get(key)))
              {
                %> 
                <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                <input type="submit" name="searchOperators-<%=name%>" value="..."/>
                <%
              }
              else if("Assignment".equalsIgnoreCase(fieldTypes.get(key)))
              {
                %> 
                <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                <input type="submit" name="searchAssignments-<%=name%>" value="..."/>
                <%
              }
              else if("Subcategory".equalsIgnoreCase(fieldTypes.get(key)))
              {
                %> 
                <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                <input type="submit" name="searchSubcategory-<%=name%>" value="..."/>
                <%
              }
              else if("ProductType".equalsIgnoreCase(fieldTypes.get(key)))
              {
                %> 
                <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                <input type="submit" name="searchProductType-<%=name%>" value="..."/>
                <%
              }
              else if("AffectedItem".equalsIgnoreCase(fieldTypes.get(key)))
              {
                %> 
                <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                <input type="submit" name="searchConfigItem-<%=name%>" value="..."/>
                <%
              }
              else if("ResolutionCode".equalsIgnoreCase(fieldTypes.get(key)))
              {
                %> 
                <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                <input type="submit" name="searchResolutionCode-<%=name%>" value="..."/>
                <%
              }
              else if("Service".equalsIgnoreCase(fieldTypes.get(key)))
              {
                %> 
                <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                <input type="submit" name="searchService-<%=name%>" value="..."/>
                <%
              }
              else if("Location".equalsIgnoreCase(fieldTypes.get(key)))
              {
                %> 
                <input type="text" name="<%=name%>" value="<%=incident.getTextValue(name, true)%>"/> 
                <input type="submit" name="searchLocation-<%=name%>" value="..."/>
                <%
              }
              %>
            </td>
          </tr>
          <%
          }
          %>
          <tr>
            <td class="no-border"></td>
            <td class="no-border"><input type="submit" name="action" value="<%=actionButton%>" /></td>
          </tr>
        </table>
        <%
        }
        %>
      </div>
    </form>

    <jsp:include page="includes/footer.jsp">
      <jsp:param name="prevlist" value="true" />
    </jsp:include>
  </body>
</html>
